--===================================================================================================================--

-- OnLoad Functions

--===================================================================================================================--

function BC_CryInputFrame_OnLoad()
	BC_CriesFrame_SetState(1);
	BC_CryInputFrame_SetState(0);
end

function BC_CryEditCategoryFrame_OnLoad()
	CryEditCategoryFrame:Show();
end

function BC_CryEditCustomCryEditActionFrame_OnLoad()
	BC_CryEditCustomCryEditActionFrame_SetState(0);
end

function BC_CryEditActionFrame_OnLoad()
	BC_CryEditActionFrame_SetState(0);
end

function BC_CryEditCryListFrame_OnLoad()
	BC_CryEditCryListFrame_SetState(0);
end

function BC_CryInputFrame_OnShow()
end
--===================================================================================================================--

-- List Button Functions

--===================================================================================================================--

function BC_CategoryButton_OnClick(index)
	BC_Debug("BC_CategoryButton_OnClick(" .. tostring(index) .. ")", 2);
	if(index > 0) then
		BC_CryEditCategoryFrame_SetState(2);
		BC_CryEditActionFrame_SetState(1);
		BC_CryEditCryListFrame_SetState(0);
		BC_CryInputFrame_SetState(0);
		BC_Selected.category = index + FauxScrollFrame_GetOffset(CryEditCategoryFrame_ListScroll);
		BC_CryEditActionFrame_Populate();
		if(BC_CategoryDB[BC_Selected.category]==BC_VARS_CATEGORYCUSTOM) then
			BC_CryEditCustomCryEditActionFrame_SetState(1);
		else
			BC_CryEditCustomCryEditActionFrame_SetState(0);
		end
	end
end

function BC_ActionButton_OnClick(index)
	BC_Debug("BC_ActionButton_OnClick(" .. tostring(index) .. ")", 2);
	if(index > 0) then
		BC_CryEditActionFrame_SetState(2);
		BC_CryEditCryListFrame_SetState(1);
		BC_CryInputFrame_SetState(1);
		BC_Selected.action = index + FauxScrollFrame_GetOffset(CryEditActionFrame_ListScroll);
		BC_CryEditCryListFrame_Populate();
		getglobal("CryEditActionFrame_FrequencySlider"):SetValue(BC_Saved.cries[BC_ActionDB[BC_Selected.action]].frequency);
		getglobal("CryEditActionFrame_CooldownEditBox"):SetText(tostring(BC_Saved.cries[BC_ActionDB[BC_Selected.action]].cooldown));
		if(BC_CategoryDB[BC_Selected.category]=="Custom") then
			BC_CryEditCustomCryEditActionFrame_SetState(1);
			CryEditCustomCryEditActionFrame_DeleteButton:Show();
		end
	end
end

function BC_CryListButton_OnClick(index)
	BC_Debug("BC_CryListButton_OnClick(" .. tostring(index) .. ")", 2);
	if(index > 0) then
		BC_CryEditCryListFrame_SetState(2);
		BC_Selected.cry = index + FauxScrollFrame_GetOffset(CryEditCryListFrame_ListScroll);
		BC_CryInputFrame_Populate(BC_ActionDB[BC_Selected.action], BC_Selected.cry);
		BC_EditConditionsFrame_LoadFromCry(BC_ActionDB[BC_Selected.action], BC_Selected.cry);
	end
end

--===================================================================================================================--

-- Button Functions

--===================================================================================================================--

function CryEditCustomCryEditActionFrame_AddButton_OnClick()
	BC_Debug("CryEditCustomCryEditActionFrame_AddButton_OnClick()", 2);
	BC_CryEditCustomCryEditActionFrame_SetState(2);
end

function CryEditCustomCryEditActionFrame_DeleteButton_OnClick()
	BC_Debug("CryEditCustomCryEditActionFrame_DeleteButton_OnClick()", 2);
	message = gsub(BC_TEXT_DELETECUSTOMCONFIRM, "XACTIONX", BC_ActionDB[BC_Selected.action]);
	CryEditCustomCryEditActionFrame_DeleteStringText:SetText(message);
	BC_CryEditCustomCryEditActionFrame_SetState(3);
end

function CryEditCustomCryEditActionFrame_AcceptButton_OnClick()
	BC_Debug("CryEditCustomCryEditActionFrame_AcceptButton_OnClick()", 2);
	if(CryEditCustomCryEditActionFrame_EditBox:IsVisible()) then
		newAction = CryEditCustomCryEditActionFrame_EditBox:GetText();
		if(newAction and newAction ~= "") then
			BC_Message(gsub(BC_TEXT_ADDCUSTOM, "XACTIONX", newAction));
			BC_SavedActions_Add(newAction);
			BC_CryEditActionFrame_Populate();
		end
	elseif(CryEditCustomCryEditActionFrame_DeleteStringText:IsVisible()) then
		BC_Message(gsub(BC_TEXT_DELETECUSTOM, "XACTIONX", BC_ActionDB[BC_Selected.action]));
		BC_SavedActions_Delete(BC_Selected.action);
		BC_CryEditActionFrame_Populate();
	end
	BC_CryEditCustomCryEditActionFrame_SetState(1);
end

function CryEditCustomCryEditActionFrame_CancelButton_OnClick()
	BC_Debug("CryEditCustomCryEditActionFrame_CancelButton_OnClick()", 2);
	BC_CryEditCustomCryEditActionFrame_SetState(1);
end

function CryEditActionFrame_SaveButton_OnClick()
	BC_Debug("CryEditActionFrame_SaveButton_OnClick()", 2);
	BC_SavedCries_SetFrequency(CryEditActionFrame_FrequencySlider:GetValue());
	BC_SavedCries_SetCooldown(CryEditActionFrame_CooldownEditBox:GetText());
	actionName = BC_ActionDB[BC_Selected.action];
	message = BC_TEXT_SAVEACTION;
	message = gsub(message, "XACTIONX", actionName);
	message = gsub(message, "XFREQUENCYX", tostring(BC_Saved.cries[actionName].frequency));
	if(tonumber(BC_Saved.cries[actionName].cooldown) > 0) then
		message = gsub(message, "XCOOLDOWNX", tostring(BC_Saved.cries[actionName].cooldown) .. " seconds");
	else
		message = gsub(message, "XCOOLDOWNX", "None");
	end
	BC_Message(message);	
end

function CryEditCryListFrame_DeleteButton_OnClick()
	BC_Debug("CryEditCryListFrame_DeleteButton_OnClick()", 2);
	 BC_SavedCries_Delete(BC_ActionDB[BC_Selected.action], BC_Selected.cry)
	 BC_CryEditCryListFrame_Populate();
end

function CryInputFrame_ConditionsButton_OnClick()
	BC_Debug("CryInputFrame_ConditionsButton_OnClick()", 2);
	BC_EditConditionsFrame_SetState(1);
	BC_CriesFrame_SetState(0);
end

function CryInputFrame_TestButton_OnClick()
	BC_Debug("CryInputFrame_TestButton_OnClick()", 2);
	local thisCry = {
		mode = UIDropDownMenu_GetSelectedID(CryInputFrame_ModesDropDown),
		text = getglobal("CryInputFrame_TextEditBox"):GetText(),
		language = UIDropDownMenu_GetSelectedID(CryInputFrame_LanguagesDropDown),
	};
	if( thisCry.mode == nil) then
		thisCry.mode = 1;
	end
	if(thisCry.text == nil or thisCry.text == "") then
		BC_Message(BC_TEXT_SAVECRY_FAIL03);
		return;
	end
	if(thisCry.language == nil) then
		thisCry.language = BC_Defaults.language;
	end
	if(BC_CheckCry(thisCry.text)==1) then
		BC_ExecuteCry(BC_FormatCry(thisCry));
	else
		BC_Message(BC_TEXT_SAVECRY_FAIL04);
	end
end

function CryInputFrame_NewButton_OnClick()
	BC_Debug("CryInputFrame_NewButton_OnClick()", 2);
	BC_CryEditCryListFrame_Populate();
	BC_EditConditionsFrame_ClearConditions();
	BC_CryInputFrame_Populate();	
end

function CryInputFrame_SaveButton_OnClick()
	CryEditActionFrame_SaveButton_OnClick();
	BC_Debug("CryInputFrame_SaveButton_OnClick()", 2);
	if(CryInputFrame_ValidateFields()==1) then
		excludeCheck = CryInputFrame_ExcludeCheckBox:GetChecked();
		alwaysCheck = CryInputFrame_AlwaysCryCheckBox:GetChecked();
		exclusiveCheck = BC_EditConditionsFrame_ExclusiveCheckbox:GetChecked();
		if(not excludeCheck) then		excludeCheck = 0;	end
		if(not alwaysCheck) then		alwaysCheck = 0;	end
		if(not exclusiveCheck) then		exclusiveCheck = 0;	end
		thisCry = {
			name = getglobal("CryInputFrame_NameEditBox"):GetText(),
			mode = UIDropDownMenu_GetSelectedID(CryInputFrame_ModesDropDown),
			text = getglobal("CryInputFrame_TextEditBox"):GetText(),
			language = UIDropDownMenu_GetSelectedID(CryInputFrame_LanguagesDropDown),
			castCode = UIDropDownMenu_GetSelectedID(CryInputFrame_CastDropDown),
			exclude = excludeCheck,
			exclusive = exclusiveCheck,
			always = alwaysCheck,
			frequency = getglobal("CryInputFrame_FrequencySlider"):GetValue();
			condition = {},
		};
		if(table.getn(BC_Conditions.ready) > 0) then
			for i=1, table.getn(BC_Conditions.ready) do
				thisCry.condition[i] =
					{target = BC_Conditions.ready[i].target,
					 variable = BC_Conditions.ready[i].variable,
					 test = BC_Conditions.ready[i].test,
					 value = BC_Conditions.ready[i].value};
			end		
		end
		BC_SavedCries_Save(BC_ActionDB[BC_Selected.action], BC_Selected.cry,thisCry);
	end
	BC_CryEditCryListFrame_Populate();
end

--===================================================================================================================--

-- CheckBox Functions

--===================================================================================================================--
function BC_CheckboxToggles(this)
	BC_Debug("BC_CheckboxToggles(" .. this:GetName() .. ")", 2);
	startCheck = CryInputFrame_StartCastCheckBox:GetChecked();
	interruptCheck = CryInputFrame_InterruptCastCheckBox:GetChecked();
	if(this:GetName()=="CryInputFrame_StartCastCheckBox") then
		if(startCheck==1 and interruptCheck==1) then
			CryInputFrame_InterruptCastCheckBox:SetChecked(0);
		end
	elseif(this:GetName()=="CryInputFrame_InterruptCastCheckBox") then
		if(startCheck==1 and interruptCheck==1) then
			CryInputFrame_StartCastCheckBox:SetChecked(0);
		end
	end	
end
--===================================================================================================================--

--DropDown Functions

--===================================================================================================================--

function BC_ModesDropDown_Initialize()
	local info;
	local count = 0;
	if(BC_VARS_MODES) then
		for i=1, table.getn(BC_VARS_MODES), 1 do
			info = {};
			info.text = BC_VARS_MODES[i];
			info.func = BC_ModesDropDownButton_OnClick;
			UIDropDownMenu_AddButton(info);
			count = count + 1;
			if(count == UIDROPDOWNMENU_MAXBUTTONS) then break; end
		end
	end
end

function BC_ModesDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BC_ModesDropDown_Initialize);
	UIDropDownMenu_SetWidth(80);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", CryInputFrame_ModesDropDown)
end

function BC_ModesDropDownButton_OnClick()
	UIDropDownMenu_SetSelectedID(CryInputFrame_ModesDropDown, this:GetID());
end

function BC_LanguagesDropDown_Initialize()
	local info;
	local count = 0;
	if(BC_Languages) then
		for i=1, getn(BC_Languages), 1 do
			info = {};
			info.text = BC_Languages[i];
			info.func = BC_LanguagesDropDownButton_OnClick;
			UIDropDownMenu_AddButton(info);
			count = count + 1;
			if(count == UIDROPDOWNMENU_MAXBUTTONS) then break; end
		end
	end
end

function BC_LanguagesDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BC_LanguagesDropDown_Initialize);
	UIDropDownMenu_SetWidth(90);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", CryInputFrame_LanguagesDropDown)
end

function BC_LanguagesDropDownButton_OnClick()
	UIDropDownMenu_SetSelectedID(CryInputFrame_LanguagesDropDown, this:GetID());
end

function BC_CastDropDown_Initialize()
	local info;
	local count = 0;
	if(BC_VARS_CASTCRY) then
		for i=1, table.getn(BC_VARS_CASTCRY), 1 do
			info = {};
			info.text = BC_VARS_CASTCRY[i];
			info.func = BC_CastDropDownButton_OnClick;
			UIDropDownMenu_AddButton(info);
			count = count + 1;
			if(count == UIDROPDOWNMENU_MAXBUTTONS) then break; end
		end
	end
end

function BC_CastDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BC_CastDropDown_Initialize);
	UIDropDownMenu_SetWidth(120);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", CryInputFrame_CastDropDown)
	UIDropDownMenu_SetSelectedID(CryInputFrame_CastDropDown,1);
	UIDropDownMenu_SetText(BC_VARS_CASTCRY[1], CryInputFrame_CastDropDown);
end

function BC_CastDropDownButton_OnClick()
	UIDropDownMenu_SetSelectedID(CryInputFrame_CastDropDown, this:GetID());
end

--===================================================================================================================--

-- Scroll Functions

--===================================================================================================================--

function BC_CryEditCategoryFrame_UpdateList()
	FauxScrollFrame_Update(CryEditCategoryFrame_ListScroll, table.getn(BC_CategoryDB), 5, 16);
	BC_Universal_UpdateList("CryEdit","Category",BC_Selected.category, 5);
end

function BC_CryEditActionFrame_UpdateList()
	FauxScrollFrame_Update(CryEditActionFrame_ListScroll, table.getn(BC_ActionDB), 9, 16);
	BC_Universal_UpdateList("CryEdit","Action",BC_Selected.action, 9);
end

function BC_CryEditCryListFrame_UpdateList()
	FauxScrollFrame_Update(CryEditCryListFrame_ListScroll, table.getn(BC_CryListDB), 9, 16);
	BC_Universal_UpdateList("CryEdit","CryList",BC_Selected.cry, 9);
end

--===================================================================================================================--

-- Frame Population Functions

--===================================================================================================================--

function BC_CryEditCategoryFrame_Populate()
	BC_Debug("BC_CryEditCategoryFrame_Populate()", 2);
	BC_CategoryDB = {};
	BC_Selected.category = 0;
	for key in pairs(BC_Spellbook) do
		tinsert(BC_CategoryDB, key);
	end
	sort(BC_CategoryDB);
	BC_CryEditCategoryFrame_UpdateList();
end

function BC_CryEditActionFrame_Populate()
	BC_Debug("BC_CryEditActionFrame_Populate()", 2);
	BC_ActionDB = {};
	BC_Selected.action = 0;
	for key in pairs(BC_Spellbook[BC_CategoryDB[BC_Selected.category]]) do
		tinsert(BC_ActionDB,BC_Spellbook[BC_CategoryDB[BC_Selected.category]][key]);
	end
	sort(BC_ActionDB);
	BC_CryEditActionFrame_UpdateList();
end

function BC_CryEditCryListFrame_Populate()
	BC_Debug("BC_CryEditCryListFrame_Populate()", 2);
	BC_CryListDB = {};
	BC_Selected.cry = 0;
	for i=1,table.getn(BC_Saved.cries[BC_ActionDB[BC_Selected.action]].cry) do
		tinsert(BC_CryListDB,BC_Saved.cries[BC_ActionDB[BC_Selected.action]].cry[i].name);
	end
	BC_CryEditCryListFrame_UpdateList();
end

function BC_CryInputFrame_Populate(action, cry)
	BC_Debug("BC_CryInputFrame_Populate("..tostring(action)..","..tostring(cry)..")", 2);
	if(action ~= nil and cry ~= nil) then
		CryInputFrame_NameEditBox:SetText(BC_Saved.cries[action].cry[cry].name);
		CryInputFrame_TextEditBox:SetText(BC_Saved.cries[action].cry[cry].text);
		UIDropDownMenu_SetSelectedID(CryInputFrame_ModesDropDown,BC_Saved.cries[action].cry[cry].mode);
		UIDropDownMenu_SetText(BC_VARS_MODES[BC_Saved.cries[action].cry[cry].mode], CryInputFrame_ModesDropDown);
		UIDropDownMenu_SetSelectedID(CryInputFrame_LanguagesDropDown,BC_Saved.cries[action].cry[cry].language);
		UIDropDownMenu_SetText(BC_Languages[BC_Saved.cries[action].cry[cry].language], CryInputFrame_LanguagesDropDown);
		UIDropDownMenu_SetSelectedID(CryInputFrame_CastDropDown,BC_Saved.cries[action].cry[cry].castCode);
		UIDropDownMenu_SetText(BC_VARS_CASTCRY[BC_Saved.cries[action].cry[cry].castCode], CryInputFrame_CastDropDown);

		getglobal("CryInputFrame_ExcludeCheckBox"):SetChecked(BC_Saved.cries[action].cry[cry].exclude);
		getglobal("CryInputFrame_AlwaysCryCheckBox"):SetChecked(BC_Saved.cries[action].cry[cry].always);
		getglobal("CryInputFrame_FrequencySlider"):SetValue(BC_Saved.cries[action].cry[cry].frequency);
		BC_EditConditionsFrame_LoadFromCry(action, cry);
		if(BC_Conditions.ready) then
			CryInputFrame_ConditionButton:SetText(BC_BUTTONLABEL_CONDITIONS .. " (" .. table.getn(BC_Conditions.ready) .. ")");
		else
			CryInputFrame_ConditionButton:SetText(BC_BUTTONLABEL_CONDITIONS);
		end
	else
		CryInputFrame_NameEditBox:SetText("");
		CryInputFrame_TextEditBox:SetText("");
		UIDropDownMenu_SetSelectedID(CryInputFrame_ModesDropDown,0);
		UIDropDownMenu_SetText("", CryInputFrame_ModesDropDown);
		UIDropDownMenu_SetSelectedID(CryInputFrame_LanguagesDropDown,0);
		UIDropDownMenu_SetText("", CryInputFrame_LanguagesDropDown);
		UIDropDownMenu_SetSelectedID(CryInputFrame_CastDropDown,1);
		UIDropDownMenu_SetText(BC_VARS_CASTCRY[1], CryInputFrame_CastDropDown);
		getglobal("CryInputFrame_ExcludeCheckBox"):SetChecked(0);
		getglobal("CryInputFrame_AlwaysCryCheckBox"):SetChecked(0);
		getglobal("CryInputFrame_FrequencySlider"):SetValue(1);
		BC_EditConditionsFrame_ClearConditions();
		CryInputFrame_ConditionButton:SetText(BC_BUTTONLABEL_CONDITIONS);
	end
end

--===================================================================================================================--

-- Frame State Functions

--===================================================================================================================--

function BC_CriesFrame_SetState(state)
	if(state==0) then
		BC_EditCriesFrame:Hide();
	elseif(state==1) then
		BC_EditCriesFrame:Show();
	end
end

function BC_CryEditCategoryFrame_SetState(state)
	if(state==0) then
		CryEditCategoryFrame:Hide();
	elseif(state==1) then
		CryEditCategoryFrame:Show();
		CryEditCategoryFrame_ListHighlight:Hide();
	elseif(state==2) then

	end
end

function BC_CryEditCustomCryEditActionFrame_SetState(state)
	if(state==0) then
		CryEditCustomCryEditActionFrame:Hide();
	else
		CryEditCustomCryEditActionFrame:Show();
		if(state==1) then
			CryEditCustomCryEditActionFrame:SetHeight(45);
			CryEditCustomCryEditActionFrame_AddButton:Show();
			CryEditCustomCryEditActionFrame_AcceptButton:Hide();
			CryEditCustomCryEditActionFrame_CancelButton:Hide();
			CryEditCustomCryEditActionFrame_DeleteString:Hide();
			CryEditCustomCryEditActionFrame_EditBox:Hide();
			if(BC_Selected.action == 0) then
				CryEditCustomCryEditActionFrame_DeleteButton:Hide();
			else
				CryEditCustomCryEditActionFrame_DeleteButton:Show();
			end
		else
			CryEditCustomCryEditActionFrame:SetHeight(80);
			CryEditCustomCryEditActionFrame_AddButton:Hide();
			CryEditCustomCryEditActionFrame_DeleteButton:Hide();
			CryEditCustomCryEditActionFrame_AcceptButton:Show();
			CryEditCustomCryEditActionFrame_CancelButton:Show();
			if(state==2) then
				CryEditCustomCryEditActionFrame_DeleteString:Hide();
				CryEditCustomCryEditActionFrame_EditBox:Show();
				CryEditCustomCryEditActionFrame_EditBox:SetFocus();
			elseif(state==3) then
				CryEditCustomCryEditActionFrame_DeleteString:Show();
				CryEditCustomCryEditActionFrame_EditBox:Hide();
			end
		end
	end
end

function BC_CryEditActionFrame_SetState(state)
	if(state==0) then
		CryEditActionFrame:Hide();
	elseif(state==1) then
		CryEditActionFrame:Show();
		CryEditActionFrame:SetHeight(170);
		CryEditActionFrame_FrequencySlider:Hide();
		CryEditActionFrame_CooldownEditBox:Hide();
		CryEditActionFrame_ListHighlight:Hide();
		CryEditActionFrame_SaveButton:Hide();
	elseif(state==2) then
		CryEditActionFrame:Show();
		CryEditActionFrame:SetHeight(235);
		CryEditActionFrame_FrequencySlider:Show();
		CryEditActionFrame_CooldownEditBox:Show();
		CryEditActionFrame_SaveButton:Show();
	end
end

function BC_CryEditCryListFrame_SetState(state)
	if(state==0) then
		CryEditCryListFrame:Hide();
	elseif(state==1) then
		CryEditCryListFrame:Show();
		CryEditCryListFrame:SetHeight(170);
		CryEditCryListFrame_ListHighlight:Hide();
		CryEditCryListFrame_DeleteButton:Hide();
	elseif(state==2) then
		CryEditCryListFrame:Show();
		CryEditCryListFrame:SetHeight(195);
		CryEditCryListFrame_DeleteButton:Show();
	end
end

function BC_CryInputFrame_SetState(state)
	if(state==0) then
		CryInputFrame:Hide();
	elseif(state==1) then
		CryInputFrame:Show();
	end
end

--===================================================================================================================--

-- Misc Functions

--===================================================================================================================--

function CryInputFrame_ValidateFields()
	BC_Debug("CryInputFrame_ValidateFields()", 2);
	local cryName = getglobal("CryInputFrame_NameEditBox"):GetText();
	local cryMode = UIDropDownMenu_GetSelectedID(CryInputFrame_ModesDropDown);
	local cryText = getglobal("CryInputFrame_TextEditBox"):GetText();
	local cryLang = UIDropDownMenu_GetSelectedID(CryInputFrame_LanguagesDropDown);
	local cryCooldown = getglobal("CryEditActionFrame_CooldownEditBox"):GetText();
	if( cryName == nil or cryName == "" ) then
		BC_Message(BC_TEXT_SAVECRY_FAIL02);
		return 0;
	end
	if( cryText == nil or cryText == "" ) then
		BC_Message(BC_TEXT_SAVECRY_FAIL03);
		return 0;
	end
	if( cryMode == nil ) then
		UIDropDownMenu_SetSelectedID(CryInputFrame_ModesDropDown,1);
		UIDropDownMenu_SetText(BC_VARS_MODES[1],CryInputFrame_ModesDropDown);
	end
	if( cryLang == nil ) then
		UIDropDownMenu_SetSelectedID(CryInputFrame_LanguagesDropDown,BC_Defaults.language);
		UIDropDownMenu_SetText(BC_Languages[BC_Defaults.language],CryInputFrame_LanguagesDropDown);
	end
	return 1;
end
