BC_EventFinderActive = false;
BC_EventFinderEvents = {};

function BC_EventFinderFrame_OnShow()
	BC_ListButton_Resize(getglobal("BC_EventFinderFrame_List"));
	for i=1, 5 do
		textBoxLabel = getglobal("BC_EventFinderFrame_Arg" .. i .. "EditBoxLabel");
		textBoxLabel:SetText(BC_EDITBOXLABEL_EVENTFINDERARG .. " " .. tostring(i));
		textBox = getglobal("BC_EventFinderFrame_Arg" .. i .. "EditBox");
		textBox:Hide();
	end
	if(BC_EventFinderActive == true) then
		BC_EventFinderFrame_ActivateButton:Hide();
		BC_EventFinderFrame_DeactivateButton:Show();
	else
		BC_EventFinderFrame_ActivateButton:Show();
		BC_EventFinderFrame_DeactivateButton:Hide();
	end
end

function BC_EventFinderFrame_OnEvent()
	if(BC_EventFinderActive == true) then
		if(table.getn(BC_EventFinderDB)<50) then
			table.insert(BC_EventFinderDB, event);
			table.insert(BC_EventFinderEvents, {["name"] = event, ["args"] = { tostring(arg1), tostring(arg2), tostring(arg3), tostring(arg4), tostring(arg5), }, });
		else
			for i=1, 49 do
				BC_EventFinderDB[i] = BC_EventFinderDB[i+1];
				BC_EventFinderEvents[i] = BC_EventFinderEvents[i+1];
			end
			BC_EventFinderDB[50] = event;
			BC_EventFinderEvents[50] = {["name"] = event, ["args"] = { arg1, arg2, arg3, arg4, arg5, }, };
			if(BC_Selected.eventFinder>0) then BC_Selected.eventFinder = BC_Selected.eventFinder - 1; end
		end
		BC_EventFinderFrame_UpdateList();
	end
end

function BC_EventFinderFrame_UpdateList()
	FauxScrollFrame_Update(BC_EventFinderFrame_ListScroll, table.getn(BC_EventFinderDB), 9, 16);
	BC_Universal_UpdateList("BC_","EventFinder",BC_Selected.eventFinder, 9);
end

function BC_EventFinderFrame_ListButton_OnClick(index)
	BC_Selected.eventFinder = index + FauxScrollFrame_GetOffset(getglobal("BC_EventFinderFrame_ListScroll"));
	BC_EventFinderFrame_UpdateList();
	BC_EventFinderFrame_LoadEvent(BC_Selected.eventFinder);
end

function BC_EventFinderFrame_EditBox_Tab(index)
	if(index==5) then
		newIndex = 1;
	else
		newIndex = index + 1;
	end
	textBox = getglobal("BC_EventFinderFrame_Arg" .. newIndex .. "EditBox");
	textBox:SetFocus();
end

function BC_EventFinderFrame_EditBox_Focus(index)
	textBox = getglobal("BC_EventFinderFrame_Arg" .. index .. "EditBox");
	textBox:HighlightText();
end

function BC_EventFinderFrame_EditBox_Unfocus(index)
	textBox = getglobal("BC_EventFinderFrame_Arg" .. index .. "EditBox");
	textBox:HighlightText(0,0);
end

function BC_EventFinderFrame_LoadEvent(index)
	if(index > 0) then
		for i=1, 5 do
			textBox = getglobal("BC_EventFinderFrame_Arg" .. i .. "EditBox");
			if(BC_EventFinderEvents[index].args[i]
			and BC_EventFinderEvents[index].args[i] ~= "nil"
			and BC_EventFinderEvents[index].args[i] ~= "") then
				textBox:SetText(BC_EventFinderEvents[index].args[i]);
				textBox:Show();
			else
				textBox:Hide();
			end
		end
	else
		for i=1, 5 do
			textBox = getglobal("BC_EventFinderFrame_Arg" .. i .. "EditBox");
			textBox:SetText("");
		end
	end
end

function BC_EventFinderFrame_ActivateEvents()
	BC_EventFinderActive = true;
	BC_EventFinderFrame_ActivateButton:Hide();
	BC_EventFinderFrame_DeactivateButton:Show();
	this:GetParent():RegisterEvent("TRAINER_SHOW");
	this:GetParent():RegisterEvent("PLAYER_REGEN_DISABLED");
	this:GetParent():RegisterEvent("PLAYER_REGEN_ENABLED");
	this:GetParent():RegisterEvent("PLAYER_LEVEL_UP");
	this:GetParent():RegisterEvent("PLAYER_CONTROL_LOST");
	this:GetParent():RegisterEvent("PLAYER_CONTROL_GAINED");
	this:GetParent():RegisterEvent("PLAYER_CAMPING");
	this:GetParent():RegisterEvent("TRADE_SHOW");
	this:GetParent():RegisterEvent("DUEL_FINISHED");
	this:GetParent():RegisterEvent("DUEL_REQUESTED");
	this:GetParent():RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
	this:GetParent():RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS");
	this:GetParent():RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:GetParent():RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
	this:GetParent():RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES");
	this:GetParent():RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS");
	this:GetParent():RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
	this:GetParent():RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");
	this:GetParent():RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE");
	this:GetParent():RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_MISSES");
	this:GetParent():RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:GetParent():RegisterEvent("CHAT_MSG_SPELL_SELF_MISSES");
	this:GetParent():RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:GetParent():RegisterEvent("COMBAT_TEXT_UPDATE");
	this:GetParent():RegisterEvent("PLAYER_TARGET_CHANGED");
	this:GetParent():RegisterEvent("RAID_TARGET_CHANGED");
	this:GetParent():RegisterEvent("UNIT_AURA");
	this:GetParent():RegisterEvent("UNIT_AURASTATE");
	this:GetParent():RegisterEvent("UNIT_COMBO_POINTS");
	this:GetParent():RegisterEvent("UNIT_ENERGY");
	this:GetParent():RegisterEvent("UNIT_FOCUS");
	this:GetParent():RegisterEvent("UNIT_HAPPINESS");
	this:GetParent():RegisterEvent("UNIT_HEALTH");
	this:GetParent():RegisterEvent("UNIT_MANA");
	this:GetParent():RegisterEvent("UNIT_RAGE");
	this:GetParent():RegisterEvent("CHAT_MSG_LOOT");
	this:GetParent():RegisterEvent("LOOT_OPENED");
	this:GetParent():RegisterEvent("LOOT_CLOSED");
end

function BC_EventFinderFrame_DeactivateEvents()
	BC_EventFinderActive = false;
	BC_EventFinderFrame_ActivateButton:Show();
	BC_EventFinderFrame_DeactivateButton:Hide();
	this:GetParent():UnregisterEvent("TRAINER_SHOW");
	this:GetParent():UnregisterEvent("PLAYER_REGEN_DISABLED");
	this:GetParent():UnregisterEvent("PLAYER_REGEN_ENABLED");
	this:GetParent():UnregisterEvent("PLAYER_LEVEL_UP");
	this:GetParent():UnregisterEvent("PLAYER_CONTROL_LOST");
	this:GetParent():UnregisterEvent("PLAYER_CONTROL_GAINED");
	this:GetParent():UnregisterEvent("PLAYER_CAMPING");
	this:GetParent():UnregisterEvent("TRADE_SHOW");
	this:GetParent():UnregisterEvent("DUEL_FINISHED");
	this:GetParent():UnregisterEvent("DUEL_REQUESTED");
	this:GetParent():UnregisterEvent("PLAYER_PVP_KILLS_CHANGED");
	this:GetParent():UnregisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS");
	this:GetParent():UnregisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:GetParent():UnregisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
	this:GetParent():UnregisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES");
	this:GetParent():UnregisterEvent("CHAT_MSG_COMBAT_SELF_HITS");
	this:GetParent():UnregisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
	this:GetParent():UnregisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");
	this:GetParent():UnregisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE");
	this:GetParent():UnregisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_MISSES");
	this:GetParent():UnregisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:GetParent():UnregisterEvent("CHAT_MSG_SPELL_SELF_MISSES");
	this:GetParent():UnregisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:GetParent():UnregisterEvent("COMBAT_TEXT_UPDATE");
	this:GetParent():UnregisterEvent("PLAYER_TARGET_CHANGED");
	this:GetParent():UnregisterEvent("RAID_TARGET_CHANGED");
	this:GetParent():UnregisterEvent("UNIT_AURA");
	this:GetParent():UnregisterEvent("UNIT_AURASTATE");
	this:GetParent():UnregisterEvent("UNIT_COMBO_POINTS");
	this:GetParent():UnregisterEvent("UNIT_ENERGY");
	this:GetParent():UnregisterEvent("UNIT_FOCUS");
	this:GetParent():UnregisterEvent("UNIT_HAPPINESS");
	this:GetParent():UnregisterEvent("UNIT_HEALTH");
	this:GetParent():UnregisterEvent("UNIT_MANA");
	this:GetParent():UnregisterEvent("UNIT_RAGE");
	this:GetParent():UnregisterEvent("CHAT_MSG_LOOT");
	this:GetParent():UnregisterEvent("LOOT_OPENED");
	this:GetParent():UnregisterEvent("LOOT_CLOSED");
end