BC_Events = { 
	registered = {},
};

function BC_EventWatchFrame_OnLoad()
	BC_EventWatchFrame_EventsFrame_TitleText:SetText(BC_VARS_CATEGORYEVENTS);
	BC_EventWatchFrame_Arg1Frame_TitleText:SetText(BC_VARS_CATEGORYARG1);
	BC_EventWatchFrame_Arg2Frame_TitleText:SetText(BC_VARS_CATEGORYARG2);
	BC_EventWatchFrame_WatchFrame_TitleText:SetText(BC_VARS_CATEGORYWATCHES);
	BC_ListButton_Resize(getglobal("BC_EventWatchFrame_EventsFrame_List"));
	BC_ListButton_Resize(getglobal("BC_EventWatchFrame_Arg1Frame_List"));
	BC_ListButton_Resize(getglobal("BC_EventWatchFrame_WatchFrame_List"));
	BC_EventWatchFrame_EventsFrame_SetState(0);
	BC_EventWatchFrame_Arg1Frame_SetState(0);
	BC_EventWatchFrame_Arg2Frame_SetState(0);
	BC_EventWatchFrame_WatchFrame_SetState(0);
	BC_EventWatchFrame_SetState(0);
end

function BC_EventWatchFrame_OnShow()
	BC_EventWatchFrame_EventsFrame_UpdateList();
	BC_EventWatchFrame_Arg1Frame_UpdateList();
	BC_EventWatchFrame_WatchFrame_UpdateList();
end

--===================================================================================================================--

-- State Functions

--===================================================================================================================--
function BC_EventWatchFrame_SetState(state)
	BC_Debug("BC_EventWatchFrame_SetState(" .. tostring(state) .. ")", 2);
	if(state==0) then
		BC_EventWatchFrame:Hide();
	elseif(state==1) then
		BC_EventWatchFrame:Show();
	end
end

function BC_EventWatchFrame_EventsFrame_SetState(state)
	BC_Debug("BC_EventWatchFrame_EventsFrame_SetState(" .. tostring(state) .. ")", 2);
	if(state==0) then
		BC_EventWatchFrame_EventsFrame_TextEditBox:Hide();
		BC_EventWatchFrame_EventsFrame:SetHeight(160);
	else
		BC_EventWatchFrame_EventsFrame_TextEditBox:Show();
		BC_EventWatchFrame_EventsFrame:SetHeight(190);
	end
end

function BC_EventWatchFrame_Arg1Frame_SetState(state)
	BC_Debug("BC_EventWatchFrame_Arg1Frame_SetState(" .. tostring(state) .. ")", 2);
	if(state==0) then
		BC_EventWatchFrame_Arg1Frame:Hide();
	else
		BC_EventWatchFrame_Arg1Frame:Show();
		if(state==1) then
			BC_EventWatchFrame_Arg1Frame:SetHeight(130);
			BC_EventWatchFrame_Arg1Frame_TextEditBox:Show();
			BC_EventWatchFrame_Arg1Frame_List:SetPoint("TOPLEFT", "BC_EventWatchFrame_Arg1Frame", "TOPLEFT", 5, -45);
			BC_EventWatchFrame_Arg1Frame_ListScroll:SetPoint("TOPLEFT", "BC_EventWatchFrame_Arg1Frame", "TOPLEFT", 5, -45);
		else
			BC_EventWatchFrame_Arg1Frame:SetHeight(110);
			BC_EventWatchFrame_Arg1Frame_TextEditBox:Hide();
			BC_EventWatchFrame_Arg1Frame_List:SetPoint("TOPLEFT", "BC_EventWatchFrame_Arg1Frame", "TOPLEFT", 5, -20);
			BC_EventWatchFrame_Arg1Frame_ListScroll:SetPoint("TOPLEFT", "BC_EventWatchFrame_Arg1Frame", "TOPLEFT", 5, -20);
		end
	end
end

function BC_EventWatchFrame_Arg2Frame_SetState(state)
	BC_Debug("BC_EventWatchFrame_Arg2Frame_SetState(" .. tostring(state) .. ")", 2);
	if(state < 2) then
		BC_EventWatchFrame_Arg2Frame:Hide();
	else
		BC_EventWatchFrame_Arg2Frame:Show();
	end
end

function BC_EventWatchFrame_WatchFrame_SetState(state)
	BC_Debug("BC_EventWatchFrame_WatchFrame_SetState(" .. tostring(state) .. ")", 2);
	if(state==0) then
		BC_EventWatchFrame_WatchFrame_SaveButton:Hide();
		BC_EventWatchFrame_WatchFrame_NameEditBox:Hide();
		BC_EventWatchFrame_WatchFrame_DeleteButton:Hide();
		BC_EventWatchFrame_WatchFrame:SetHeight(160);
	elseif(state==1) then
		BC_EventWatchFrame_WatchFrame_SaveButton:Show();
		BC_EventWatchFrame_WatchFrame_NameEditBox:Show();
		BC_EventWatchFrame_WatchFrame_DeleteButton:Hide();
		BC_EventWatchFrame_WatchFrame:SetHeight(230);
	else
		BC_EventWatchFrame_WatchFrame_SaveButton:Show();
		BC_EventWatchFrame_WatchFrame_NameEditBox:Show();
		BC_EventWatchFrame_WatchFrame_DeleteButton:Show();
		BC_EventWatchFrame_WatchFrame:SetHeight(260);
	end
end

function BC_EventWatchFrame_EventName_Convert(name)
	BC_Debug("BC_EventWatchFrame_EventName_Convert(" .. tostring(name) .. ")", 2);
	name = strsub(name,1,1) .. strlower(strsub(name, 2));
	for j=1, strlen(name) do
		if(strsub(name,j,j)=="_") then
			name = strsub(name,1,j-1) .. " " .. strupper(strsub(name,j+1,j+1)) .. strsub(name,j+2);
		end
	end
	return name;
end

--===================================================================================================================--

-- Populate Functions

--===================================================================================================================--
function BC_EventWatchFrame_Populate()
	BC_EventWatchFrame_EventsFrame_Populate();
	BC_EventWatchFrame_EventsFrame_UpdateList();

	BC_EventWatchFrame_WatchFrame_Populate();
	BC_EventWatchFrame_WatchFrame_UpdateList();
end

function BC_EventWatchFrame_EventsFrame_Populate()
	BC_Debug("BC_EventWatchFrame_EventsFrame_Populate()", 2);
	BC_EventsDB = {};
	BC_Selected.event = 0;
	for key in pairs(BC_Defaults.events) do
		name = tostring(key);
		tinsert(BC_EventsDB, name);
	end
	sort(BC_EventsDB);
end

function BC_EventWatchFrame_Arg1Frame_Populate()
	BC_Debug("BC_EventWatchFrame_Arg1Frame_Populate()", 2);
	BC_Arg1DB = {};
	BC_Selected.arg1 = 0;
	BC_EventWatchFrame_Arg1Frame_TextEditBox:SetText("");
	if(BC_Defaults.events[BC_EventsDB[BC_Selected.event]].watchType > 0) then
		for i = 1, table.getn(BC_Defaults.events[BC_EventsDB[BC_Selected.event]].args) do
			tinsert(BC_Arg1DB, BC_Defaults.events[BC_EventsDB[BC_Selected.event]].args[i]);
		end
	end
end

function BC_EventWatchFrame_Arg2Frame_Populate()
	BC_Debug("BC_EventWatchFrame_Arg2Frame_Populate()", 2);
	if(BC_Defaults.events[BC_EventsDB[BC_Selected.event]].watchType > 1) then
		BC_EventWatchFrame_Arg2Frame:Show();
	else
		BC_EventWatchFrame_Arg2Frame:Hide();
	end
end

function BC_EventWatchFrame_WatchFrame_Populate()
	BC_Debug("BC_EventWatchFrame_WatchFrame_Populate()", 2);
	BC_WatchDB = {};
	BC_Selected.watch = 0;
	for key in pairs(BC_Saved.events) do
		tinsert(BC_WatchDB, key);
	end
	sort(BC_WatchDB);
end

--===================================================================================================================--

-- Scroll Functions

--===================================================================================================================--
function BC_EventWatchFrame_EventsFrame_UpdateList()
	FauxScrollFrame_Update(BC_EventWatchFrame_EventsFrame_ListScroll, table.getn(BC_EventsDB), 9, 16);
	BC_Universal_UpdateList("BC_EventWatchFrame_","Events",BC_Selected.event, 9);
end

function BC_EventWatchFrame_Arg1Frame_UpdateList()
	FauxScrollFrame_Update(BC_EventWatchFrame_Arg1Frame_ListScroll, table.getn(BC_Arg1DB), 5, 16);
	BC_Universal_UpdateList("BC_EventWatchFrame_","Arg1",BC_Selected.arg1, 5);
end

function BC_EventWatchFrame_WatchFrame_UpdateList()
	FauxScrollFrame_Update(BC_EventWatchFrame_WatchFrame_ListScroll, table.getn(BC_WatchDB), 9, 16);
	BC_Universal_UpdateList("BC_EventWatchFrame_","Watch",BC_Selected.watch, 9);
end

--===================================================================================================================--

-- List Button Functions

--===================================================================================================================--
function BC_EventWatchFrame_EventsFrame_ListButton_OnClick(index)
	BC_Selected.event = index + FauxScrollFrame_GetOffset(getglobal("BC_EventWatchFrame_EventsFrame_ListScroll"));
	BC_EventWatchFrame_Arg1Frame_Populate();
	BC_EventWatchFrame_Arg1Frame_SetState(BC_Defaults.events[BC_EventsDB[BC_Selected.event]].watchType);
	BC_EventWatchFrame_Arg2Frame_Populate();
	BC_EventWatchFrame_WatchFrame_SetState(1);
	BC_EventWatchFrame_Arg1Frame_UpdateList();
end

function BC_EventWatchFrame_Arg1Frame_ListButton_OnClick(index)
	BC_Selected.arg1 = index + FauxScrollFrame_GetOffset(getglobal("BC_EventWatchFrame_Arg1Frame_ListScroll"));
	BC_EventWatchFrame_Arg1Frame_TextEditBox:SetText(BC_Defaults.events[BC_EventsDB[BC_Selected.event]].args[BC_Selected.arg1]);
end

function BC_EventWatchFrame_WatchFrame_ListButton_OnClick(index)
	BC_Debug("BC_EventWatchFrame_WatchFrame_ListButton_OnClick(" .. tostring(index) .. ")", 2);
	BC_Selected.watch = index + FauxScrollFrame_GetOffset(getglobal("BC_EventWatchFrame_WatchFrame_ListScroll"));
	watchName = BC_WatchDB[BC_Selected.watch];
	for j=1, table.getn(BC_EventsDB) do
		if(BC_EventsDB[j] == BC_Saved.events[watchName].event) then
			BC_Selected.event = j;
			watchType = BC_Defaults.events[BC_EventsDB[j]].watchType;
		end
	end
	BC_EventWatchFrame_EventsFrame_UpdateList();
	BC_EventWatchFrame_Arg1Frame_Populate();
	BC_EventWatchFrame_Arg1Frame_SetState(watchType);
	BC_EventWatchFrame_Arg2Frame_Populate();
	BC_EventWatchFrame_Arg2Frame_SetState(watchType);
	BC_EventWatchFrame_WatchFrame_SetState(2);
	if(BC_Saved.events[watchName].args) then
		text = BC_Saved.events[watchName].args[1];
		if(not text) then
			text = "";
		else
			for j=1, table.getn(BC_Arg1DB) do
				if(BC_Arg1DB[j] == BC_Saved.events[watchName].args[1]) then
					BC_Selected.arg1 = j;
				end
			end
		end
		BC_EventWatchFrame_Arg1Frame_TextEditBox:SetText(text);
		text = BC_Saved.events[watchName].args[2];
		if(not text) then text = ""; end
		BC_EventWatchFrame_Arg2Frame_TextEditBox:SetText(text);
	end
	BC_EventWatchFrame_WatchFrame_NameEditBox:SetText(watchName);
	BC_EventWatchFrame_Arg1Frame_UpdateList();
end
--===================================================================================================================--

-- UI Button Functions

--===================================================================================================================--
function BC_EventWatchFrame_SaveButton_OnClick()
	BC_EventWatch_SaveWatch();
end

function BC_EventWatchFrame_DeleteButton_OnClick()
	BC_EventWatch_DeleteWatch();
end

--===================================================================================================================--

-- Event Watch DB Functions

--===================================================================================================================--
function BC_EventWatch_SaveWatch()
	watch = {
		["name"] = BC_EventWatchFrame_WatchFrame_NameEditBox:GetText(),
		["event"] = BC_EventsDB[BC_Selected.event],
		["arg1"] = BC_EventWatchFrame_Arg1Frame_TextEditBox:GetText(),
		["arg2"] = BC_EventWatchFrame_Arg2Frame_TextEditBox:GetText(),
		["watchType"] = BC_Defaults.events[BC_EventsDB[BC_Selected.event]].watchType,
	};
	if(BC_EventWatch_Validate(watch)) then
		BC_Message(watch.name .. BC_TEXT_EVENTWATCH_SAVE_SUCCESS);
		BC_Saved.events[watch.name] = {
			["event"] = watch.event;
			["args"] = {
				[1] = watch.arg1;
				[2] = watch.arg2;
			},
		};
		BC_Saved.cries[watch.name] = { frequency = 0, cooldown = 0, cry = {},};
		BC_Events.registered[watch.event] = 0;
		BC_EventWatchFrame_WatchFrame_Populate();
		BC_EventWatchFrame_WatchFrame_UpdateList();
		BC_PopulateSpellbook();
	end
end

function BC_EventWatch_DeleteWatch()
	name = BC_WatchDB[BC_Selected.watch];
	if(name) then
		BC_Saved.events[name] = nil;
		BC_Saved.cries[name] = nil;
		BC_Selected.watch = 0;
		BC_Message(name .. BC_TEXT_EVENTWATCH_DELETE_SUCCESS);
		BC_EventWatchFrame_WatchFrame_Populate();
		BC_EventWatchFrame_WatchFrame_UpdateList();
		BC_PopulateSpellbook();
	end
end

function BC_EventWatch_Validate(watch)
	if(watch.name == nil or watch.name == "") then
		BC_Message(BC_TEXT_EVENTWATCH_SAVE_FAIL_01);
		return false;
	end
	if(watch.event == nil or watch.event == "") then
		BC_Message(BC_TEXT_EVENTWATCH_SAVE_FAIL_02);
		return false;
	end
	return true;
end

--===================================================================================================================--

-- Initialize/Registration Functions

--===================================================================================================================--
function BC_Initialize_Events()
	BC_Debug("BC_Initialize_Events()", 2);
	n = 0;
	if(BC_Saved.events) then
		for _ in pairs(BC_Saved.events) do
			n = n + 1;
		end
	end
	if(n == 0) then
		BC_Debug("No Events Saved.", 3);
		BC_Saved.events = {
			["You Camp"] = {
				["event"] = "PLAYER_CAMPING",
			},
			["Visit Trainer"] = {
				["event"] = "TRAINER_SHOW",
			},
			["Duel Finish"] = {
				["event"] = "DUEL_FINISHED",
			},
			["Duel Requested"] = {
				["event"] = "DUEL_REQUESTED",
			},
			["You Level Up"] = {
				["event"] = "PLAYER_LEVEL_UP",
			},
			["You Lose Control"] = {
				["event"] = "PLAYER_CONTROL_LOST",
			},
			["Trade Window Opened"] = {
				["event"] = "TRADE_SHOW",
			},
			["Leave Combat"] = {
				["event"] = "PLAYER_REGEN_ENABLED",
			},
			["Enter Combat"] = {
				["event"] = "PLAYER_REGEN_DISABLED",
			},
			["You Slay Hostile"] = {
				["event"] = "CHAT_MSG_COMBAT_HOSTILE_DEATH",
				["args"] = {
					[1] = "You have slain %s!",
				},
			},
			["You Crit (Special)"] = {
				["event"] = "CHAT_MSG_COMBAT_SELF_HITS",
				["args"] = {
					[1] = "Your %s crits %s for %d %s damage..",
				},
			},
			["You Hit (Special)"] = {
				["event"] = "CHAT_MSG_COMBAT_SELF_HITS",
				["args"] = {
					[1] = "Your %s hits %s for %d %s damage..",
				},
			},
			["You Crit (Physical)"] = {
				["event"] = "CHAT_MSG_COMBAT_SELF_HITS",
				["args"] = {
					[1] = "You crit %s for %d.",
				},
			},
			["You Get Crit (Physical)"] = {
				["event"] = "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS",
				["args"] = {
					[1] = "%s crits you for %d.",
				},
			},
			["Buff Gained"] = {
				["event"] = "COMBAT_TEXT_UPDATE",
				["args"] = {
					[1] = "AURA_START",
				},
			},
			["Buff Lost"] = {
				["event"] = "COMBAT_TEXT_UPDATE",
				["args"] = {
					[1] = "AURA_END",
				},
			},
			["Debuff Gained"] = {
				["event"] = "COMBAT_TEXT_UPDATE",
				["args"] = {
					[1] = "AURA_START_HARMFUL",
				},
			},
			["Debuff Lost"] = {
				["event"] = "COMBAT_TEXT_UPDATE",
				["args"] = {
					[1] = "AURA_END_HARMFUL",
				},
			},
		};
	end
	for key in pairs(BC_Saved.events) do
		BC_Events.registered[BC_Saved.events[key].event] = 0;
		if(not BC_Saved.cries[key]) then
			BC_Saved.cries[key] = { frequency = 0, cooldown = 0, cry = {}, };
		end
	end
	for key in pairs(BC_Saved.events) do
		if(table.getn(BC_Saved.cries[key].cry) > 0) then
			for i=1, table.getn(BC_Saved.cries[key].cry) do
				BC_EventCry_Register(BC_Saved.events[key].event);
			end
		else
			BC_Events.registered[BC_Saved.events[key].event] = 0;
		end
	end
end

function BC_EventCry_Register(eventName)
	BC_Debug("BC_EventCry_Register(" .. eventName .. ")",2);
	if(BC_Events.registered[eventName] > 0) then
		BC_Debug(eventName .. " already registered.",3);
		BC_Events.registered[eventName] = BC_Events.registered[eventName] + 1;
	else
		BC_Debug("Registering event " .. eventName, 2);
		BC_Events.registered[eventName] = 1;
		getglobal("BC_MainFrame"):RegisterEvent(eventName);
	end
end

function BC_EventCry_Unregister(eventName)
	BC_Debug("BC_EventCry_Unegister(" .. eventName .. ")",2);
	if(BC_Events.registered[eventName] == 0) then
		BC_Debug(eventName .. " already unregistered.",3);
	else
		BC_Events.registered[eventName] = BC_Events.registered[eventName] - 1;
		if(BC_Events.registered[eventName] == 0) then
			BC_Debug("Unregistering event " .. eventName, 2);
			getglobal("BC_MainFrame"):UnregisterEvent(eventName);
		end
	end
end

--===================================================================================================================--

-- Event Execution Functions

--===================================================================================================================--
function BC_EventManagement(event)
	BC_Debug("BC_EventManagement(" .. tostring(event) .. ")",2);
	if(not BC_Vars.disabled) then
		if(event) then
			eventName = BC_Event_GetName(event);
			if(eventName) then
				if(BC_Saved.cries[eventName]) then
					if(BC_Vars.echo) then
						BC_Message(BC_TEXT_ECHO .. eventName);
					end
					if(BC_CheckCooldown(eventName) > 0) then
						if(BC_Defaults.events[event].watchType == 2) then
							BC_Loaded.event = {};
							i = 1;
							arg = getglobal("arg" .. i);
							while(arg) do
								table.insert(BC_Loaded.event, arg);
								i = i + 1;
								arg = getglobal("arg" .. i);
							end
						end
						BC_ActionSucceeded(eventName);
					end
				else
					BC_Loaded.cry = {};
					BC_Loaded.chain = {};
				end
			end
		end
	end
end

function BC_Event_GetName(event)
	for key in pairs(BC_Saved.events) do
		if(event == BC_Saved.events[key].event) then
			if(BC_Saved.events[key].args) then
				found = true;
				for i=1, table.getn(BC_Saved.events[key].args) do
					if(BC_Saved.events[key].args[i] ~= "") then
						if(not BC_Events_Compare(BC_Saved.events[key].args[i], tostring(getglobal("arg" .. i)))) then
							found = false;
						end
					end
				end
				if(found) then
					return key; 
				end
			else
				return key;
			end
		end
	end
	return nil;
end

function BC_Events_Compare(search, eventMessage)
	BC_Debug("BC_Events_Compare(" .. tostring(search) .. ", " .. tostring(eventMessage) .. ")",2);
	if(search == eventMessage) then
		return true;
	end
	search = string.gsub(search, "%(", "");
	search = string.gsub(search, "%)", "");
	eventMessage = string.gsub(eventMessage, "%(", "");
	eventMessage = string.gsub(eventMessage, "%)", "");
	pieces = {};
	locStart = 1;
	locEnd = strfind(search, "%%");
	while locEnd do
		table.insert(pieces, strsub(search, locStart, locEnd-1));
		locStart = locEnd + 2;
		locEnd = strfind(search, "%%", locStart );
	end
	table.insert(pieces, strsub(search, locStart));
	for key, value in pairs(pieces) do
		if string.find(eventMessage, value) == nil then
			return false;
		end
	end
	BC_Debug("Message found. " .. eventMessage, 3);
	BC_Loaded.event = {};
	for i=1, table.getn(pieces) do
		locStart = strfind(eventMessage, pieces[i],1,true);
		BC_Debug("Message is: <" .. eventMessage .. ">, piece is: <" .. pieces[i] .. "> found at " .. tostring(locStart), 3);
		if(locStart == 1) then
			BC_Debug("Stripped out: " .. pieces[i], 3);
			eventMessage = gsub(eventMessage, pieces[i], "");
		else
			BC_Debug("Stripped out: " .. strsub(eventMessage, 1, locStart+strlen(pieces[i])-1), 3);
			table.insert(BC_Loaded.event, strsub(eventMessage, 1, locStart-1));
			eventMessage = gsub(eventMessage, strsub(eventMessage, 1, locStart-1), "");
			eventMessage = gsub(eventMessage, pieces[i], "");
		end
	end
	return true;
end

function BC_EventVariables_Replace(text)
	loc = strfind(text, "$e");
	while(loc) do
		index = tonumber(strsub(text,loc+2,loc+2));
		replaced = "$e" .. tostring(index);
		if(BC_Loaded.event[index]) then
			text = gsub(text, replaced, BC_Loaded.event[index]);
			loc = strfind(text, "$e");
		else
			loc = nil;
		end
	end
	return text;
end

function BC_EventVariable(index)
	return BC_Loaded.event[index];
end

function BC_ActionsWithCries()
	cries = {};
	for key in pairs(BC_Saved.cries) do
		if(table.getn(BC_Saved.cries[key].cry)>0) then
			tinsert(cries, key);
		end
	end
	return cries;
end