BC_CryList = {};
CRY_INFO.cryNum = 0;

--===================================================================================================================--

--Slider Functions

--===================================================================================================================--

function BC_SetFrequency(value)
	if(CRY_INFO.actionName) then
		BC_Debug("Frequency slider set to " .. value .. "% for " .. CRY_INFO.actionName);
		BC_List[CRY_INFO.actionName].frequency = value;
	end
end

function BC_GetFrequency()
	if(CRY_INFO.actionName) then
		BC_Debug("Getting Frequency for " .. CRY_INFO.actionName .. ": " .. BC_List[CRY_INFO.actionName].frequency);
		return BC_List[CRY_INFO.actionName].frequency;
	else
		return nil;
	end
end

--===================================================================================================================--

--DropDown Functions

--===================================================================================================================--
function BC_CategoriesDropDown_Initialize()
	local info;
	local count = 0;
	for key, _ in CRY_SPELLBOOK do
		info = {};
		info.text = key;
		info.func = BC_CategoriesDropDownButton_OnClick;
		UIDropDownMenu_AddButton(info);
		count = count + 1;
		if(count == MAX_CRIES) then break; end
	end
end

function BC_CategoriesDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BC_CategoriesDropDown_Initialize);
	UIDropDownMenu_SetWidth(120);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", BC_CryEditFrame_CategoriesDropDown)
end

function BC_CategoriesDropDownButton_OnClick()
	BC_ClearActionSelection();
	UIDropDownMenu_SetSelectedID(BC_CryEditFrame_CategoriesDropDown, this:GetID());
	CRY_INFO.currentCategory = UIDropDownMenu_GetText(BC_CryEditFrame_CategoriesDropDown);
	if(CRY_INFO.currentCategory == BC_CATEGORY_CUSTOM) then
		BC_CustomAddButton:Show();
		BC_CustomDeleteButton:Show();
	else
		BC_CustomAddButton:Hide();
		BC_CustomDeleteButton:Hide();
	end
end

function BC_ActionsDropDown_Initialize()
	local info;
	local count = 0;
	if(CRY_INFO.currentCategory) then
		for i=1, getn(CRY_SPELLBOOK[CRY_INFO.currentCategory]) do
			info = {};
			info.text = CRY_SPELLBOOK[CRY_INFO.currentCategory][i];
			info.func = BC_ActionsDropDownButton_OnClick;
			UIDropDownMenu_AddButton(info);
			count = count + 1;
			if(count == MAX_CRIES) then break; end
		end
	end
end

function BC_ActionsDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BC_ActionsDropDown_Initialize);
	UIDropDownMenu_SetWidth(150);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", BC_CryEditFrame_ActionsDropDown)
end

function BC_ActionsDropDownButton_OnClick()
	BC_CryEditFrame_PercentageSlider:Show();
	BC_CryEditFrame_ConditionButton:Show();
	BC_CryEditFrame_SaveButton:Show();
	BC_CryEditFrame_PostCastCheckBox:Show();
	BC_CryEditFrame_ExcludeCheckBox:Show();
	BC_CryEditFrame_AlwaysCryCheckBox:Show();
	UIDropDownMenu_SetSelectedID(BC_CryEditFrame_ActionsDropDown, this:GetID());
	BC_SetCurrentAction(this:GetID());
	CRY_INFO.actionName = this:GetText();
	getglobal("BC_CryEditFrame_PercentageSlider"):SetValue(BC_GetFrequency());
	BC_ClearCrySelection();
end

--===================================================================================================================--

--List Functions

--===================================================================================================================--
function BC_CryEditFrame_PopulateCryList()
	BC_CryList = {};
	if(table.getn(BC_List[CRY_INFO.actionName].cry)>0) then
		for i=1, table.getn(BC_List[CRY_INFO.actionName].cry) do
			tinsert(BC_CryList, BC_List[CRY_INFO.actionName].cry[i].name);
		end
	end
end

function BC_CryEditFrame_UpdateCryList()
	FauxScrollFrame_Update(BC_CryListScrollFrame, table.getn(BC_CryList), BC_MAXLISTITEM-1, BC_MAXLISTITEM);
	local topItem = FauxScrollFrame_GetOffset(BC_CryListScrollFrame);
	local item=1;
	for i=topItem+1, topItem + BC_MAXLISTITEM do
		local listButton = getglobal("BC_CryEditFrame_CryListItem" .. item);
		if(BC_CryList[i]) then
			if(listButton) then
				listButton:SetText(BC_CryList[i]);
				listButton:Show();
			end
		else
			listButton:Hide();
		end
		item = tonumber(item) + 1;
	end
end

function BC_ListButton_OnClick(arg1)
	if(CRY_INFO.cryNum ~= FauxScrollFrame_GetOffset(BC_CryListScrollFrame) + this:GetID()) then
		CRY_INFO.cryNum = FauxScrollFrame_GetOffset(BC_CryListScrollFrame) + this:GetID();
		BC_CryEditFrame_CryListHighlightTexture:SetVertexColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		BC_CryEditFrame_CryListHighlight:SetPoint("TOPLEFT", "BC_CryEditFrame_CryListItem"..this:GetID(), "TOPLEFT", 5, 0);
		BC_CryEditFrame_CryListHighlight:Show();
		CRY_INFO.cryName = BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].name;
		BC_CryEditFrame_DeleteButton:Show();
		getglobal("BC_CryEditFrame_CryNameEditBox"):SetText(CRY_INFO.cryName);
		getglobal("BC_CryEditFrame_CryTextEditBox"):SetText(BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].text);
		UIDropDownMenu_SetSelectedID(BC_CryEditFrame_ModesDropDown,BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].mode);
		UIDropDownMenu_SetText(CRY_MODES[BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].mode], BC_CryEditFrame_ModesDropDown);
		UIDropDownMenu_SetSelectedID(BC_CryEditFrame_LanguagesDropDown,BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].language);
		UIDropDownMenu_SetText(CRY_LANGUAGES[BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].language], BC_CryEditFrame_LanguagesDropDown);
		getglobal("BC_CryEditFrame_PostCastCheckBox"):SetChecked(BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].post);
		getglobal("BC_CryEditFrame_ExcludeCheckBox"):SetChecked(BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].exclude);
		getglobal("BC_CryEditFrame_AlwaysCryCheckBox"):SetChecked(BC_List[CRY_INFO.actionName].cry[CRY_INFO.cryNum].always);
		BC_CondResetButton_OnClick();
	end
end

function BC_ListButton_OnEnter()
	button = getglobal(this:GetName());
	button:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
end

function BC_ListButton_OnLeave()
	button = getglobal(this:GetName());
	button:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
end

function BC_CryListScroll_OnVerticalScroll()
	FauxScrollFrame_OnVerticalScroll(BC_MAXLISTITEM, BC_CryEditFrame_UpdateCryList);
	highlight = CRY_INFO.cryNum - FauxScrollFrame_GetOffset(BC_CryListScrollFrame);
	if(highlight > 0 and highlight < 6) then
		BC_CryEditFrame_CryListHighlight:SetPoint("TOPLEFT", "BC_CryEditFrame_CryListItem"..tostring(highlight), "TOPLEFT", 5, 0);
		BC_CryEditFrame_CryListHighlight:Show();
	else
		BC_CryEditFrame_CryListHighlight:Hide();
	end
end

--===================================================================================================================--

--General Functions

--===================================================================================================================--

function BC_ClearCrySelection()
	BC_CryEditFrame_DeleteButton:Hide();
	BC_CryEditFrame_CryListHighlight:Hide();
	CRY_INFO.cryNum = 0;
	CRY_INFO.cryName = nil;
	BC_ClearConditions();
	if(CRY_INFO.actionName) then
		BC_CryEditFrame_PopulateCryList();
		BC_CryEditFrame_UpdateCryList();
	end
end

function BC_ClearActionSelection()
	BC_ClearCrySelection();
	BC_CryEditFrame_ActionsDropDown:Show();
	BC_CryEditFrame_PercentageSlider:Hide();
	BC_CryEditFrame_ConditionButton:Hide();
	BC_CryEditFrame_SaveButton:Hide();
	BC_CryEditFrame_DeleteButton:Hide();
	BC_CryEditFrame_PostCastCheckBox:Hide();
	BC_CryEditFrame_ExcludeCheckBox:Hide();
	BC_CryEditFrame_AlwaysCryCheckBox:Hide();
	BC_CryEditFrame_CryListHighlight:Hide();
	UIDropDownMenu_SetSelectedID(BC_CryEditFrame_ActionsDropDown,0);
	UIDropDownMenu_SetText("", BC_CryEditFrame_ActionsDropDown);
	BC_CryList = { };
	BC_CryEditFrame_UpdateCryList();
	CRY_INFO.cryNum = nil;
	CRY_INFO.actionName = nil;
end