function BC_Tooltip_SetText(frame)
	if(not BC_Tooltips[frame:GetName()]) then 
		BC_Tooltip:AddLine("No Help Available");
		return false;
	end
	text = BC_Tooltips[frame:GetName()].text;
	lines = {};
	locStart = 1;
	locEnd = 40;
	while(strlen(text) > locEnd) do
		lastSpace = strlen(text);
		for i=1, locEnd do
			if(strsub(text,i,i,true)==" ") then
				lastSpace = i;
			end
		end
		table.insert(lines, strsub(text, locStart, lastSpace - 1));
		text = strsub(text, lastSpace + 1);
	end
	table.insert(lines, text);
	color = { r = 1, g = 1, b = 1};
	BC_Tooltip:AddLine(BC_Tooltips[frame:GetName()].name, color.r, color.g, color.b);
	color = { r = NORMAL_FONT_COLOR_r, g = NORMAL_FONT_COLOR_g, b = NORMAL_FONT_COLOR_b };
	for i=1, table.getn(lines) do
		BC_Tooltip:AddLine(lines[i], color.r, color.g, color.b);
	end
	return true;
end

function BC_Tooltip_Set(frame)
	BC_MainFrame.TooltipButton = frame:GetID();
	BC_Tooltip:SetOwner(frame, "ANCHOR_BOTTOMRIGHT");
	if(BC_Tooltip_SetText(frame)) then
		BC_Tooltip:Show();
	else
		BC_Message(frame:GetName());
	end
end

function BC_Tooltip_Unset()
	BC_Tooltip:Hide();
end