--===================================================================================================================--

-- Frame Functions

--===================================================================================================================--

function BC_MainFrame_OnShow()
	BC_MainFrame_DisableCheckBox:SetChecked(BC_Vars.disabled);
	BC_Initialize_DB();
	if(BC_Selected.category == 0) then
		BC_PopulateSpellbook();
		BC_PopulatePetbook();
		BC_CryEditCustomCryEditActionFrame_SetState(0);
		BC_CryEditCustomCryEditActionFrame_SetState(0);
		BC_CryEditActionFrame_SetState(0);
		BC_CryEditCryListFrame_SetState(0);
		BC_CryEditCategoryFrame_Populate();
	end
end

--===================================================================================================================--

-- List Button Functions

--===================================================================================================================--

function BC_ListButton_OnClick(arg1)
	BC_Debug("BC_ListButton_OnClick(" .. arg1 .. ")", 2);
	buttonName = this:GetName();
	BC_Debug(buttonName, 4);
	highlightButtonName = strsub(buttonName,1,strlen(buttonName)-5) .. "Highlight";
	highlightButton = getglobal(highlightButtonName);
	getglobal(highlightButtonName .. "Texture"):SetVertexColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	highlightButton:SetPoint("TOPLEFT", buttonName, "TOPLEFT", 5, 0);
	highlightButton:Show();
	if(strsub(buttonName,1,7)=="CryEdit") then
		buttonName = gsub(buttonName, "CryEdit","");
		buttonName = gsub(buttonName, "Frame_ListItem" .. tostring(this:GetID()),"");
		func = getglobal("BC_" .. buttonName .. "Button_OnClick");
		func(this:GetID());
	end
	if(strsub(buttonName,1,11)=="ChainSelect") then
		buttonName = gsub(buttonName, "ChainSelect","");
		link = strsub(buttonName,1,4);
		buttonName = gsub(buttonName, link .. "_", "");
		buttonName = gsub(buttonName, "Frame_ListItem" .. tostring(this:GetID()),"");
		func = getglobal("BC_Chain" .. buttonName .. "Button_OnClick");
		func(link, this:GetID());
	end
	if(strsub(buttonName,1,11)=="SavedChains") then
		buttonName = gsub(buttonName, "CryEdit","");
		buttonName = gsub(buttonName, "Frame_ListItem" .. tostring(this:GetID()),"");
		BC_SavedChainsListButton_OnClick(this:GetID());
	end
	if(strsub(buttonName,1,17)=="BC_EditConditions") then
		BC_EditConditionsFrame_ListButton_OnClick(this:GetID());
	end
	if(strsub(buttonName,1,30)=="BC_EventWatchFrame_EventsFrame") then
		BC_EventWatchFrame_EventsFrame_ListButton_OnClick(this:GetID());
	end
	if(strsub(buttonName,1,28)=="BC_EventWatchFrame_Arg1Frame") then
		BC_EventWatchFrame_Arg1Frame_ListButton_OnClick(this:GetID());
	end
	if(strsub(buttonName,1,29)=="BC_EventWatchFrame_WatchFrame") then
		BC_EventWatchFrame_WatchFrame_ListButton_OnClick(this:GetID());
	end
	if(strsub(buttonName,1,19)=="BC_EventFinderFrame") then
		BC_EventFinderFrame_ListButton_OnClick(this:GetID());
	end
end

function BC_ListButton_OnEnter()
	button = getglobal(this:GetName());
	button:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
end

function BC_ListButton_OnLeave()
	button = getglobal(this:GetName());
	button:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
end

function BC_ListButton_Resize(frame)
	width = frame:GetWidth();
	i = 1;
	button = getglobal(frame:GetName() .. "Item" .. tostring(i));
	while(button) do
		button:SetWidth(width-20);
		getglobal(button:GetName() .. "Text"):SetWidth(width-20);
		i = i + 1;
		button = getglobal(frame:GetName() .. "Item" .. tostring(i));
	end
	getglobal(frame:GetName() .. "Highlight"):SetWidth(width - 20);
	getglobal(frame:GetName() .. "HighlightTexture"):SetWidth(width - 20);
	getglobal(frame:GetName() .. "HighlightTexture"):SetVertexColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
end

--===================================================================================================================--

-- Scroll Functions

--===================================================================================================================--

function BC_Universal_UpdateList(pageName, frameName, selected, maximum)
--	BC_Debug("BC_Universal_UpdateList(" .. pageName .. ", " .. frameName .. ", " .. selected .. ", " .. maximum .. ")", 2);
	scrollFrame = getglobal(pageName .. frameName .. "Frame_ListScroll");
	local topItem = FauxScrollFrame_GetOffset(scrollFrame);
	local item=1;
	for i=topItem+1, topItem + maximum do
		local listButton = getglobal(pageName .. frameName .. "Frame_ListItem" .. item);
		db = getglobal("BC_" .. frameName .. "DB");
		if(db[i]) then
			if(listButton) then
				listButton:SetText(db[i]);
				listButton:Show();
			end
		else
			listButton:Hide();
		end
		item = tonumber(item) + 1;
	end
	highlight = selected - topItem;
	highlightButton = getglobal(pageName .. frameName .. "Frame_ListHighlight");
	if(highlight > 0 and highlight <= maximum) then
		highlightButton:SetPoint("TOPLEFT", pageName .. frameName .. "Frame_ListItem" .. tostring(highlight), "TOPLEFT", 5, 0);
		highlightButton:Show();
	else
		highlightButton:Hide();
	end
end

--===================================================================================================================--

-- CheckBox Functions

--===================================================================================================================--

function BC_MainFrame_DisableCheckBox_Click()
	BC_Vars.disabled = BC_MainFrame_DisableCheckBox:GetChecked();
end

--===================================================================================================================--

-- Help Functions

--===================================================================================================================--
function BC_Message(message)
	DEFAULT_CHAT_FRAME:AddMessage(tostring(message));
end

function BC_Debug(message, color)
	if(BC_Vars.debug) then
		if(color) then
			thisColor = { 
				[1] = "|CFF808080",
				[2] = "|CFFF04040 - ",
				[3] = "|CFF40F040 - - ",
				[4] = "|CFF4040F0 - - - ",
			};
			message = thisColor[color] .. tostring(message) .. "|r";
		end
		DEFAULT_CHAT_FRAME:AddMessage(tostring(message));
	end
end